#ifndef NBODY_DATASTRUCTURE_HH
#define NBODY_DATASTRUCTURE_HH

#include <array>
#include <vector>
#include <cassert>
#include <cmath>


// type for representing vectors in R^2
typedef std::array<double,2> Vector2D;

// variant 1
struct Body
{
  Vector2D r_i;
  Vector2D v_i;
  double m_i;
  
  // compare two bodies
  bool operator==(const Body& b) const
  {
    return (r_i == b.r_i && v_i == b.v_i && std::fabs(m_i-b.m_i)/std::fabs(m_i+b.m_i)<1e-16);
  }
};

// new DataStructure Quadrant should look like this
// please fill in the functions
struct Quadrant
{
  Quadrant(const Vector2D ll, const Vector2D ur)
  Quadrant()
   
  bool contains(const Vector2D& point)
  
  double length() const
  
  Quadrant NO()
  
  Quadrant SO()

  Quadrant SW()

  Quadrant NW()
 
  private:
  Vector2D lowerLeft;
  Vector2D upperRight;
  
};


// Node of a Quad Tree Structure
struct QuadTreeNode
{  
  QuadTreeNode(Quadrant q)
    : body(), quad(q), children()
  {}
  QuadTreeNode()
    : body(), quad(), children()
  {}  

  bool isLeaf = true;
  bool isEmpty = true;
  Body body;
  Quadrant quad;

  std::vector<QuadTreeNode> children;   
};

// typedefs for both considered data structures
using DataVariant1 = std::vector<Body>;

#endif // NBODY_DATASTRUCTURE_HH
